;; Copyright 2007, 2008, 2009, 2010, 2012, 2013 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------
;; after-change-functions save-match-data

(add-to-list 'mode-line-misc-info '(:eval (my-mode-line-bit)))
(defun my-mode-line-bit ()
  (looking-at ".")
  "abc")
(progn
  (looking-at "..")
  (force-mode-line-update)
  (match-data))



;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

;;-----------------
;; emacs20

;; no {} count
(looking-at "x\\{2\\}")
xx


          (setq re (format "\\(%s \\).*?\\( ?%s\\)"
                           re
                           (apply 'concat (make-list (length re)
                                                     "\\(>\\|\\'\\)"))))

;;-----------------

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (require 'perl-pod-gt)
  (find-file "d-perl-pod-gt.pl")
  (perl-pod-gt-enable)
  (font-lock-mode 1))
(setq debug-on-error t)

;;-----------------

(let ((overlay (make-overlay (point-min) (point-max)
			     (current-buffer) nil nil)))
  (overlay-put overlay 'face 'perl-pod-gt-warn))

(progn
  (require 'cl)
  (dolist (overlay (overlays-in (point-min) (point-max))
		   )
    (delete-overlay overlay)))

;;-----------------

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))


;;-----------------

(progn
  (provide 'overlay)
  (add-to-list 'load-path (expand-file-name ".."))
  (require 'perl-pod-gt)
  (perl-pod-gt-enable))


;;-----------------

(let ((tempfile "/tmp/x.el")
      (print-level nil))
  (require 'autoload)
  (find-file tempfile)
  (erase-buffer)
  (generate-file-autoloads "../perl-pod-gt.el")
  (save-buffer)
  (byte-compile-file tempfile)
  (delete-file (concat tempfile "c"))
  (delete-file tempfile))

;;-----------------




jkfdsjf ksdf jksd fjksd  fdksjjf dskfj sdkf fdjksf jksd fjksd jf
ksd 


(setq fill-nobreak-predicate nil)
(add-hook 'fill-nobreak-predicate 'fill-french-nobreak-p)

(progn

  (font-lock-mode))

   C<<foo->bar>>
   C<foo->bar>

   C<fE<lt> E<gt>oo->bar->quux>
   C<fE<lt> E<gt>oo->_bar->_Quux>

   C<<foo => bar>>
   C<x => y, a => b>
   C<fE<lt> E<gt>oo=>bar>

   I<<< foo => bar >>>
   I<<< x >>>
 
(font-lock-add-keywords nil
                        '(("\\(FIXME\\)" 1 font-lock-warning-face prepend)
                          ("\\<\\(and\\|or\\|not\\)\\>" . font-lock-keyword-face)))

FIXME: fdjsk 

(add-to-list 'font-lock-keywords
             ( )
'cperl-font-lock-keywords

;; 'cperl-font-lock-keywords-1
;; 'cperl-font-lock-keywords-2

