#!/usr/bin/perl -w

# Copyright 2008, 2009, 2010 Kevin Ryde.

# This file is part of miscbits-el.
#
# miscbits-el is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 3, or (at your option) any later
# version.
#
# miscbits-el is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with miscbits-el; see the file COPYING.  Failing that, go to
# <http://www.gnu.org/licenses/>.


use Storable;
use Data::Dumper;
use strict;
use warnings;
use FindBin;
use File::Spec;

{
  use Storable;
  my $data = [ { foo => "two chars \x{C2}\x{2022}" },
               { bar => "one byte \x98" },
             ];
  my $filename = File::Spec->catfile ($FindBin::Bin, 'd-pst-format.pst0');
  Storable::store ($data, $filename)
      or die "Cannot store to $filename";
  system "ls -l $filename";
  exit 0;
}

{
  binmode (STDOUT, ':encoding(utf8)') or die 'Oops, binmode error';
  # print Data::Dumper->Dump([$data],[$name]);
  print "\x{2022}\n";
  exit 0;
}
__END__







use Storable;
use Data::Dumper;
use strict;
use warnings;

my $orig_qquote = \&Data::Dumper::qquote;
sub my_qquote {
  my ($str) = @_;
  if (utf8::is_utf8($str)) {
    $str=~s/([\x00-\x08\x0B-\x1F\x7F])/sprintf('\\x{%02x}',ord($1))/ge;
    return '"' . $str . '"';
  } else {
    goto $orig_qquote;
  }
}
*Data::Dumper::qquote = \&my_qquote;

$Data::Dumper::Sortkeys = 1;
$Data::Dumper::Useqq = 1;
$Data::Dumper::Indent = 1;
$data = Storable::retrieve('/home/gg/lisp/test/t-pst-format.pst0');
my $name = Storable::last_op_in_netorder()
  ? 'data (host byte order)' : 'data (network byte order)';
binmode STDOUT, ':utf8' or die 'Oops, binmode error';
print Data::Dumper->Dump([$data],[$name]);

exit 0;
