;; Copyright 2009, 2010, 2012 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------------------------------------------------------------------
;; doubled directories in load-path
(let (alist)
  (require 'cl)
  (switch-to-buffer "load-path-output")
  (erase-buffer)
  (dolist (dir load-path)
    (let ((basename (file-name-nondirectory (directory-file-name dir))))
      (unless (assoc basename alist)
        (push (list basename) alist))
      (nconc (assoc basename alist)
             (list dir))))
  (setq alist (sort* alist 'string-lessp :key 'car))
  (dolist (elem alist)
    (when (>= (length elem) 4)
      (insert (car elem) "\n")
      (dolist (dir (cdr elem))
        (insert "  " dir "\n"))))
  (goto-char (point-min)))

;;-----------------------------------------------------------------------------
;; non-flavour directories in load-path
(progn
  (switch-to-buffer "load-path-output")
  (erase-buffer)
  (dolist (dir load-path)
    (unless (string-match "emacs/?23" dir)
      (insert dir "\n")
      (redisplay t))))


;;-----------------------------------------------------------------------------
;; elc's without el
(dolist (dir load-path)
  (when (file-exists-p dir)
    (let ((elc-list (directory-files dir nil "\\.elc\\'" t)))
      (dolist (elc-file elc-list)
        (let ((basename (file-name-sans-extension elc-file)))
          (let ((el-file (locate-library (concat basename ".el") t)))
            (unless el-file
              (insert dir "/" elc-file "\n")
              (redisplay t))))))))
