;; Copyright 2014, 2015 Kevin Ryde
;;
;; my-nut.el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; my-nut.el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You can get a copy of the GNU General Public License online at
;; <http://www.gnu.org/licenses/>.


;; In the menus.txt output of the "nut" program (Debian nut-nutrition) show
;; a total for the food at point.

(define-key text-mode-map [f8]  'my-nut-total)

(defun my-nut-total ()
  (interactive)
  (save-excursion
    (require 'thingatpt)
    (let* ((food
            (if (thing-at-point-looking-at "\\(gm\\|oz\\) +\\([-A-Z0-9(), ]+\\)")
                (match-string 2)
              (error "No nut match")
              ;; "SOY PROTEIN ISOLATE"
              ;; "NAYTURA"
              ;; "CRANBERRIES,DRIED,SWEETENED"
              ;; "MEAT DRIPPINGS(LARD,BEEF TALLOW,MUTTON TALLOW)"
              ;; "OLIVES,PICKLED,CANNED OR BOTTLED,GREEN"
              ))
           (re    (concat "^ *\\([0-9.-]+\\) *g.*" (regexp-quote food)))
           (total 0)
           (count 0))
      (goto-char (point-min))
      (while (re-search-forward re nil t)
        (setq total (+ total (string-to-number (match-string 1))))
        (setq count (1+ count)))
      (message "%s total %sg  %s" count total food)
      re)))

